// ====================================================================
// Allan CORNET
// Simon LIPP
// INRIA 2008
// This file is released into the public domain
// ====================================================================

if MSDOS then
  // to manage long pathname
  includes_src_c = '-I""' + get_absolute_file_path('builder_gateway_c.sce') + '../../src/c""';
else
  includes_src_c = '-I' + get_absolute_file_path('builder_gateway_c.sce') + '../../src/c';
end

// PutLhsVar managed by user in sci_sum and in sci_sub
// if you do not this variable, PutLhsVar is added
// in gateway generated (default mode in scilab 4.x and 5.x)
WITHOUT_AUTO_PUTLHSVAR = %t;

tbx_build_gateway('edflib_c', ['edf_load','sci_edfload';'edf_ann','sci_edfann';'edf_write','sci_edfwrite';'edf_close','sci_edfclose';'edf_set_patient_info','sci_edf_set_patient_additional'; ..
'edf_set_admincode', 'sci_edf_set_admincode' ;'edf_set_birthdate', 'sci_edf_set_birthdate' ;'edf_set_digital_maximum', 'sci_edf_set_digital_maximum' ;'edf_set_digital_minimum', 'sci_edf_set_digital_minimum' ;..
'edf_set_equipment', 'sci_edf_set_equipment' ;'edf_set_gender', 'sci_edf_set_gender' ;'edf_set_label', 'sci_edf_set_label' ;'edf_set_patientcode', 'sci_edf_set_patientcode' ; ..
'edf_set_patientname', 'sci_edf_set_patientname' ;'edf_set_physical_dim', 'sci_edf_set_physical_dimension' ;'edf_set_physical_maximum', 'sci_edf_set_physical_maximum' ;..
'edf_set_physical_minimum', 'sci_edf_set_physical_minimum' ;'edf_set_prefilter', 'sci_edf_set_prefilter' ;'edf_set_recording_info', 'sci_edf_set_recording_additional'; ..
'edf_set_samplefrequency', 'sci_edf_set_samplefrequency' ;'edf_set_startdatetime', 'sci_edf_set_startdatetime' ;'edf_set_technician', 'sci_edf_set_technician' ;'edf_set_transducer', 'sci_edf_set_transducer'; ..
'edfwrite_physical_samples', 'sci_edfwrite_physical_samples';..
'edf_get_patient_info', 'sci_edf_get_patient_additional'; 'edf_get_admincode', 'sci_edf_get_admincode';..
'edf_get_birthdate', 'sci_edf_get_birthdate' ; 'edf_get_equipment','sci_edf_get_equipment';..
'edf_get_gender','sci_edf_get_gender';'edf_get_patientcode','sci_edf_get_patientcode';..
'edf_get_patientname','sci_edf_get_patientname';'edf_get_recording_info','sci_edf_get_recording_additional';..
'edf_get_technician','sci_edf_get_technician';'edf_get_digital_maximum','sci_edf_get_digital_maximum';..
'edf_get_digital_minimum','sci_edf_get_digital_minimum';'edf_get_physical_maximum','sci_edf_get_physical_maximum';..
'edf_get_physical_minimum','sci_edf_get_physical_minimum';'edf_get_label','sci_edf_get_label';..
'edf_get_physical_dim','sci_edf_get_physical_dimension';'edf_get_prefilter','sci_edf_get_prefilter';..
'edf_get_samplefrequency', 'sci_edf_get_samplefrequency';'edf_get_edfsignals', 'sci_edf_get_edfsignals';..
'edf_get_signal_samples', 'sci_edf_get_signal_samples';'edf_get_file_duration','sci_edf_get_file_duration';..
'edf_get_startdatetime','sci_edf_get_startdatetime';'edfwrite_annotation_utf8','sci_edfwrite_annotation_utf8';..
'edfwrite_annotation_latin1','sci_edfwrite_annotation_latin1';'edf_get_transducer','sci_edf_get_transducer';..
], ..
['sci_edfload.c','sci_edfann.c','sci_edfwrite.c','sci_edfclose.c','sci_edf_set_patient_additional.c','sci_edf_set_admincode.c','sci_edf_set_birthdate.c','sci_edf_set_digital_maximum.c', ..
'sci_edf_set_digital_minimum.c','sci_edf_set_equipment.c','sci_edf_set_gender.c','sci_edf_set_label.c','sci_edf_set_patientcode.c','sci_edf_set_patientname.c','sci_edf_set_physical_dimension.c',..
'sci_edf_set_physical_maximum.c','sci_edf_set_physical_minimum.c','sci_edf_set_prefilter.c','sci_edf_set_recording_additional.c','sci_edf_set_samplefrequency.c','sci_edf_set_startdatetime.c',..
'sci_edf_set_technician.c','sci_edf_set_transducer.c','sci_edfwrite_physical_samples.c',..
'sci_edf_get_patient_additional.c', 'sci_edf_get_admincode.c', 'sci_edf_get_birthdate.c','sci_edf_get_equipment.c','sci_edf_get_gender.c','sci_edf_get_patientcode.c',..
'sci_edf_get_patientname.c','sci_edf_get_recording_additional.c','sci_edf_get_technician.c','sci_edf_get_digital_maximum.c','sci_edf_get_digital_minimum.c',..
'sci_edf_get_physical_maximum.c','sci_edf_get_physical_minimum.c','sci_edf_get_label.c','sci_edf_get_physical_dimension.c','sci_edf_get_prefilter.c',..
'sci_edf_get_samplefrequency.c','sci_edf_get_edfsignals.c','sci_edf_get_signal_samples.c', 'sci_edf_get_file_duration.c', 'sci_edf_get_startdatetime.c',..
'sci_edfwrite_annotation_utf8.c','sci_edfwrite_annotation_latin1.c','sci_edf_get_transducer.c'], ..
                  get_absolute_file_path('builder_gateway_c.sce'), ..
                  ['../../src/c/libedf'],'',includes_src_c);

clear WITHOUT_AUTO_PUTLHSVAR;

clear tbx_build_gateway;
// 